﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;
using Newtonsoft.Json;
using Syncfusion.JavaScript;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public IEnumerable currentData;
        public ActionResult Index(){
            ViewBag.datasource = new NorthwindDataContext().OrdersViews.ToList();
            ViewBag.datasource1 = new NorthwindDataContext().EmployeeViews.ToList();
            return View();
        }
        public ActionResult BatchDataSource(DataManager dm)
        {
            IEnumerable<OrdersView> DataSource =  new NorthwindDataContext().OrdersViews.ToList();
            DataResult result = new DataResult();
            result.result = DataSource.Skip(dm.Skip).Take(dm.Take);
            result.count = DataSource.Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult BatchUpdate(List<EditableOrder> changed, List<EditableOrder> added, List<EditableOrder> deleted)
        {
            if (changed != null)
                OrderRepository.Update(changed);
            if (deleted != null)
                OrderRepository.Delete(deleted);
            if (added != null)
                OrderRepository.Add(added);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }

        public ActionResult Update(OrdersView value)
        {
            var ds = new NorthwindDataContext();
            var query = from ord in ds.OrdersViews where ord.OrderID == value.OrderID select ord;
            foreach (OrdersView ord in query)
            {
                ord.OrderID = value.OrderID;
                ord.EmployeeID = value.EmployeeID;
                ord.ShipCity = value.ShipCity;
                ord.ShipName = value.ShipName;
                ord.Freight = value.Freight;
            }
            ds.SubmitChanges();
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(OrdersView value)
        {
            var ds = new NorthwindDataContext();
            //throw new InvalidOperationException("there is already an Item with the same name in the database");

           // ds.OrdersViews.InsertOnSubmit(value);
            ds.SubmitChanges();

           // var jsonData = OrderRepository.GetEditable(value);

            return Json(value, JsonRequestBehavior.AllowGet);
            //OrderRepository.GetEditable(value);
            //var data = OrderRepository.GetAllRecords();
            //return Json(data, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            var ds = new NorthwindDataContext();
            var query = from ord in ds.OrdersViews where ord.OrderID == key select ord;

            //foreach (OrdersView detail in query)
              //  ds.OrdersViews.DeleteOnSubmit(detail);
            ds.SubmitChanges();
            return Json(key, JsonRequestBehavior.AllowGet);
        }
        public class DataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
            public IEnumerable aggregate { get; set; }
            public IEnumerable groupDs { get; set; }
        }
    }
}